/*
 *  ngtk/test/menu_test.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>
#include "ngtk_test.h"

ngtk_menu_t *menu_test_m;

void cleanup_menu_test(void)
{
    ngtk_topbar(56, A_NORMAL, version_info, 0);
}

void menu_return(char *str)
{
    ngtk_commonbox(16, A_BOLD, "Menu Return", "You selected ", str);
}

void item_1(void)
{
    menu_return("Item #1");
}

void item_2(void)
{
    menu_return("Item #2");
}

void item_3(void)
{
    menu_return("Item #3");
}

void single_item(void)
{
    menu_return("a single item");
}

void sub_menu(void)
{
    void (*func)();
    const char *sub_strs[3] = { "Item #1 ", "Item #2 ", "Item #3 " };
    const void *sub_funcs[3] = { item_1, item_2, item_3 };
    ngtk_menu_t *sub_menu_m;

    sub_menu_m = ngtk_mk_menu("Sub Menu", 3, sub_strs, sub_funcs);
    ngtk_show_menu(sub_menu_m, menu_test_m->current_item+menu_test_m->top+1, \
                   (menu_test_m->max_item_len+menu_test_m->left+4), \
                   RED_F(CYAN_B), A_NORMAL, WHITE_F(RED_B), A_NORMAL, 1);

	while (!sub_menu_m->clear_flag) {
	    func = ngtk_manage_menu(sub_menu_m);
            func();
	}

    ngtk_hide_menu(sub_menu_m);
    ngtk_destroy_menu(sub_menu_m);
}

void menu_test(void)
{
    void (*func)();
    const char *tst_str[2] = { "Sub Menu >", "Single Item" };
    const void *tst_func[2] = { sub_menu, single_item };

    ngtk_topbar(56, A_NORMAL, " Menu Test. Up/Down: move selection, Enter: select, Escape: cancel", 0);
    menu_test_m = ngtk_mk_menu("Menu Test", 2, tst_str, tst_func);
    ngtk_show_menu(menu_test_m, 8, 2, BLACK_F(WHITE_B), A_BOLD, WHITE_F(BLACK_B), A_NORMAL, 1);

    while (!menu_test_m->clear_flag) {
        func = ngtk_manage_menu(menu_test_m);
        func();
    }

    ngtk_hide_menu(menu_test_m);
    ngtk_destroy_menu(menu_test_m);

    cleanup_menu_test();
}

void init_menu_test(void)
{
    ngtk_register_key(NGTK_KEY_F(3), menu_test, "F3", "Menu", 1);
}
