/*
 *  ngtk/test/quit.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>
#include "ngtk_test.h"

void cleanup_quit(void)
{
    ngtk_topbar(BLACK_F(WHITE_B), A_NORMAL, version_info, 0);
}

void quit(void)
{
    ngtk_topbar(BLACK_F(WHITE_B), A_BOLD, " Leaving NGTK Test Program...", 0);

    if (ngtk_auto_yesnobox(BLACK_F(WHITE_B), A_NORMAL, "Exit", "Really quit ?", 1) == 1) {
        cleanup_quit();
		ngtk_fade_out();
        ngtk_stop_display();
		ngtk_fade_in();
        exit(0);
    }
    cleanup_quit();
}

void init_quit()
{
    int ialtx = 0x114;
    char *saltx = "\033x";

    ngtk_define_keysym(saltx, ialtx);

    ngtk_register_key(ialtx, quit, "M-x", "Quit", 1);
}
